# @sourcegraph/event-logger

A library for logging events to Sourcegraph's internal telemetry engine. Uses Sourcegraph `logEvent` GraphQL API.

### Installation
- using yarn: `yarn add @sourcegraph/event-logger`
- using npm: `npm install @sourcegraph/event-logger`
### Usage:

```tsx
import {EventLogger} from `@sourcegraph/event-logger`

const eventLogger = new EventLogger('my-instance-of-sourcegraph.example');

eventLogger.log('MyCustomEvent')
```

### API

#### `constructor(sourcegraphURL: string)`:
- `sourcegraphURL`: Sourcegraph instance URL

#### `eventLogger.log(eventName?: string, argument?: any, publicArgument?: any)`:
- `eventName`: name of the event to be logged
- `argument` (**optional**): event metadata 
- `publicArgument` (**optional**): event public metadata

### Development
> NOTE: if you don't have any @sourcegraph npm org NPM_TOKEN, comment out `.npmrc` file contents
1. Install dependencies: `yarn install`
2. Use [yarn link](https://classic.yarnpkg.com/en/docs/cli/link) to install npm package in other repository without publishing

### Testing
- `yarn run test`: TODO: add unit tests

### Publishing
> TODO: configure CI to publish on merge to main
1. Create publish access token and set it to `NPM_TOKEN` environment variable. 
> Note: access token should have access to `@sourcegraph` npm org
2. Bump version: `npm version {major|minor|patch}`
3. Open terminal and run `npm publish --access public`