export declare class EventLogger {
    private sourcegraphURL;
    private anonymousUserID;
    private cohortID?;
    private firstSourceURL;
    private cookieSettings;
    constructor(sourcegraphURL: string);
    /**
     * Log a `ViewStaticPage`event with the provided URL as a parameter.
     *
     * @param {string} url the URL to be logged.
     */
    log(eventName: string, eventProperties?: any, publicArgument?: any): Promise<void>;
    private logToConsole;
    /**
     * Gets the anonymous user ID and cohort ID of the user from cookies.
     * If user doesn't have an anonymous user ID yet, a new one is generated, along with
     * a cohort ID of the week the user first visited.
     *
     * If the user already has an anonymous user ID before the introduction of cohort IDs,
     * the user will not haved a cohort ID.
     *
     * If user had an anonymous user ID in localStorage, it will be migrated to cookies.
     */
    private initializeLogParameters;
    private getFirstSourceURL;
    private getPreviousMonday;
    private getReferrer;
}
